Bug 35674 - Silent discarding of code on syntax error in anonymous delegate
Summary: Silent discarding of code on syntax error in anonymous delegate
Status: RESOLVED FIXED
Alias: None
Product: Compilers
Classification: Mono
Component: C# (show other bugs)
Version: unspecified
Hardware: Macintosh Mac OS
: --- normal
Target Milestone: ---
Assignee: Marek Safar
URL:
Depends on:
Blocks:
 
Reported: 2015-11-09 04:42 UTC by Dan Nilsson
Modified: 2015-11-10 06:00 UTC (History)
1 user (show)

See Also:
Tags:
Is this bug a regression?: ---
Last known good build:


Attachments

Description Dan Nilsson 2015-11-09 04:42:16 UTC
The following program can be compiled and run, even though the statement "n = o" is invalid. No code for the 'Call' call will be generated, instead silently discarded.

Steps to reproduce:

1. Compile the program
2. Run it

Observe that the program compiles and runs even though it has a syntax error and no code has been generated for the 'Call' function call.

Expected result:

A compiler error is generated.

-------------

class MainClass
{
	public delegate void Fn(MainClass o);

	public static void Call(Fn f)
	{
		System.Console.WriteLine("called");
		f(null);
	}

	public static void Main (string[] args)
	{
		Call (delegate (MainClass o) {
			n = o;
			MainClass n = new MainClass ();
		});
	}
}
Comment 1 Marek Safar 2015-11-10 06:00:08 UTC
Fixed in master

Notice (2018-05-21): bugzilla.xamarin.com will be switching to read-only mode on Thursday, 2018-05-25 22:00 UTC.

Please join us on Visual Studio Developer Community and GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs and copy them to the new locations as needed for follow-up. The See Also field on each Bugzilla bug will be updated with a link to its new location when applicable.

After Bugzilla is read-only, if you have new information to add for a bug that does not yet have a matching issue on Developer Community or GitHub, you can create a follow-up issue in the new location. Copy and paste the title and description from this bug, and then add your new details. You can get a pre-formatted version of the title and description here:

In special cases you might also want the comments:

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.

Note You need to log in before you can comment on or make changes to this bug.